let table;

function preload() {
    table = loadTable( 
      	"https://gist.githubusercontent.com/olga-kondr/a6575a490021f75659906cc9ec077a25/raw/0d75a8111a8b99e02af9b1e78689fea84455fe7f/movies.csv",
        "csv", 
        "header"
    );
}

function setup() {
    createCanvas(500, 500);
    background(240);
}

function draw() {
    noStroke();
    fill(150, 150, 150);
    textSize(16);
    text('MPAA Rating of the Movie of the Year.', 100, 20);
    textSize(12);
    
    counterRows = table.getRowCount();
    let dict = {};
    for (let k = 0; k < counterRows; k++) {
      let val = table.getString(k, 3);
      console.log(val);
      if (val in dict) {
        let temp = dict[val] + 1;
        dict[val] = temp;  
      }else{
        dict[val] = 1;
      }
    }
    console.log(dict);

    stroke(color(190, 190, 190));
    let step = 3;
    for (let i = 0; i < counterRows/4; i++) {
      line(100, 450-i*60, 400, 450-i*60);
      noStroke();
      textAlign(RIGHT);
      text(step*(i), 80, 450-60*i);
      textAlign(LEFT);
      stroke(color(190, 190, 190));
    }

    noStroke();
    push();
    let axisy = radians(270);
    translate(20, 180);
    rotate(axisy);
    textSize(16);
    text('Count', -50, 10);
    textSize(12);
    pop();

    let len = 6*7;
    let xStart = 7*4;
    let j = 0;
    for (const property in dict) {
      stroke(color(190, 190, 190));
      fill(74, 191, 63);
      rect(100+xStart*(j+1)+j*len, 450-dict[property]*20, len, dict[property]*20);
      noStroke();
      fill(150, 150, 150);
      text(property, 135+(xStart+len+1)*j, 470);
      j += 1;
    }

    
    noStroke();
    textSize(16);
    text('MPAA Rating', 220, 495);
    textSize(12);

    stroke(color(0, 0, 0));
    line(100, 450, 100, 45)
    line(100, 450, 450, 450);
    noStroke();
    textAlign(RIGHT);
    text('0', 80, 450);
    textAlign(LEFT);
}
